import { GraphQLUnionType } from 'graphql';
import { getScalarTypeFromClass } from './scalar-type';
import { GRAPHQL_OBJECT_TYPE_MAP, getObjectTypeFromClass } from './object-type';
export function UnionType(config) {
    return (target) => {
        GRAPHQL_OBJECT_TYPE_MAP.set(target, new GraphQLUnionType({
            name: config.name,
            resolveType: (...args) => {
                const type = config.resolveType(...args);
                return getObjectTypeFromClass(type) || getScalarTypeFromClass(type) || type;
            },
            types: config.types.map(type => getObjectTypeFromClass(type) || getScalarTypeFromClass(type) || type),
        }));
        return target;
    };
}
//# sourceMappingURL=union-type.js.map