"use strict";
// tslint:disable-next-line:no-reference
/// <reference path="../../node_modules/reflect-metadata/index.d.ts" />
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_1 = require("graphql");
const object_type_1 = require("./object-type");
function InterfaceType(config = {}) {
    return target => {
        const classes = Reflect.getMetadata(object_type_1.CLASSES, target) || [];
        classes.push(target);
        Reflect.defineMetadata(object_type_1.CLASSES, classes, target);
        if (config.injector) {
            object_type_1.CONTEXT_INJECTOR_FACTORY_MAP.set(target, config.injector);
        }
        const existingGraphQLObjectTypeQueue = object_type_1.GRAPHQL_OBJECT_TYPE_CONFIG_BUILD_QUEUE_MAP.get(target) || [];
        existingGraphQLObjectTypeQueue.push(() => {
            const classes = Reflect.getMetadata(object_type_1.CLASSES, target);
            const classIndex = classes.indexOf(target);
            let superClassConfig = {};
            if (classIndex > 0) {
                const superClass = classes[classIndex - 1];
                object_type_1.getObjectTypeFromClass(superClass);
                superClassConfig = object_type_1.GRAPHQL_OBJECT_TYPE_CONFIG_MAP.get(superClass);
            }
            const existingConfig = object_type_1.GRAPHQL_OBJECT_TYPE_CONFIG_MAP.get(target) || superClassConfig;
            object_type_1.GRAPHQL_OBJECT_TYPE_MAP.set(target, new graphql_1.GraphQLInterfaceType(Object.assign({ name: config.name || target.name, resolveType: function (root, ...args) {
                    const fieldType = config.resolveType.call(root, root, ...args);
                    return object_type_1.getObjectTypeFromClass(fieldType) || fieldType;
                } }, existingConfig)));
        });
        object_type_1.GRAPHQL_OBJECT_TYPE_CONFIG_BUILD_QUEUE_MAP.set(target, existingGraphQLObjectTypeQueue);
        return target;
    };
}
exports.InterfaceType = InterfaceType;
//# sourceMappingURL=interface-type.js.map